EDIT - bug #6296

Simple search for common names returns duplicates
12/22/2016 02:05 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 4.5

Severity: critical Found in Version:

Description

This is a bug the cdmlib-services
For example:
http -b http://api.cybertaxonomy.org/salvador/portal/taxon/find. json\?doTaxaByCommonNames\=1\&doMi
sappliedNames\=0\&doSynonyms\=0\&doTaxa\=0\&pageNumber\=0\&pageSize\=25\&query\=amate\&tree\=b010c
84d-6049-45f4-9f13-c065101eaa26 | jg '.records[].titleCache'
NOTE: The http command is from httpie
Broken queries:
e http://api.cybertaxonomy.org/flora_cuba/portal/taxon/find.json?doTaxaByCommonNames=18&doSynonyms=1&doTaxa=1&page
Number=0&pageSize=25&query=Dioscorea&tree=5de394de-9c76-4b97-b04d-71be31c7{44b

o http://api.cybertaxonomy.org/salvador/portal/taxon/find.json?doTaxaByCommonNames=1&pageNumber=0&pageSize=25&quer
y=amate&tree=b010c84d-6049-45f4-9f13-c065101eaa26

TODO:

1. Implement tests for theses search mode combinations. DONE: cdmlib|cc95089
2. fix the bug

Associated revisions

Revision 83112989 - 01/09/2017 03:11 PM - Katja Luther

fix #6296: include the common name search into the search query of taxa and synonyms

Revision d841fb5d - 01/09/2017 03:39 PM - Katja Luther
ref #6296: minor

Revision d1382189 - 01/09/2017 03:46 PM - Katja Luther
ref #6296: minor

Revision 7304d345 - 01/20/2017 09:24 AM - Katja Luther

fixed copy paste error for common name search

Revision c4f7a205 - 01/20/2017 01:01 PM - Katja Luther

fix #6296: fix problems for simple search

Revision cc95089b - 01/23/2017 09:21 AM - Andreas Kohlbecker
ref #6296 more tests for findByTaxaAndName

Revision 177a283a - 01/23/2017 12:06 PM - Katja Luther

fix #6296: fix the parameter settings in search queries

Revision 4e6f5b53 - 01/23/2017 12:26 PM - Andreas Kohlbecker

ref #6296 confirming that modified expectations are correct, removing FIXMEs
Revision c57b7a71 - 11/15/2021 09:40 AM - Katja Luther
ref #6296: cleanup

History

#1 - 01/05/2017 03:53 PM - Andreas Miiller
- Assignee changed from Andreas Muiller to Katja Luther
- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to Release 4.5

#2 - 01/06/2017 09:24 AM - Katja Luther

This is a problem in the lucene search, if a taxon has two common names starting with "amate" the lucene search returns the taxon two times. We
need to add a duplicate filter.

#3 - 01/06/2017 11:54 AM - Katja Luther

tested findByEverythingFullText(), but this works fine also with more than one common name starting with the same word.
@AK which service method is called for the simple search?

#4 - 01/09/2017 09:34 AM - Andreas Kohlbecker
The method in question is

Pager<IdentifiableEntity> eu.etaxonomy.cdm.api.service.TaxonServiceImpl.findTaxaAndNames (
IFindTaxaAndNamesConfigurator configurator)

so this issue has nothing to do with the free text search.
The results of the common names search is simply added to the result set in findTaxaAndNames after the search by accepted name, synonym,

misapplied name has been done. The first search process already returns a pager object of the desired size. Adding the results of the common name
search completely breaks the paging mechanism. The search for common names thus must be integrated into the preceding search step.

#5 - 01/09/2017 02:32 PM - Katja Luther

The commonNameSearch is now integrated into the taxa and synonym search query.

#6 - 01/09/2017 03:12 PM - Katja Luther
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|83112989da231228857d6330f10d14286e93e6fe.

#7 - 01/09/2017 03:29 PM - Andreas Kohlbecker

- Status changed from Resolved to In Progress

With the test case mentioned in #6317 an exception is thrown:

2017-01-09 15:26:32.283:WARN:0ejs.ServletHandler:/portal/taxon/find. json
org.hibernate.hqgl.internal.ast.QuerySyntaxException: unexpected token: f near line 1, column 196 [select t.id
from eu.etaxonomy.cdm.model.taxon.Taxon t Jjoin t.taxonNodes as tn join t.descriptions d join d.descriptionEle
ments e join e.feature f WHERE tn.classification = :classificationAND f.supportsCommonTaxonName = true and
e.name LIKE :queryString]

at org.hibernate.hgl.internal.ast.QuerySyntaxException.convert (QuerySyntaxException. java:74)

at org.hibernate.hgl.internal.ast.ErrorCounter.throwQueryException (ErrorCounter. java:91)

at org.hibernate.hgl.internal.ast.QueryTranslatorImpl.parse (QueryTranslatorImpl.java:288)

at org.hibernate.hgl.internal.ast.QueryTranslatorImpl.doCompile (QueryTranslatorImpl. java:187)

at org.hibernate.hgl.internal.ast.QueryTranslatorImpl.compile (QueryTranslatorImpl.java:142)

at org.hibernate.engine.query.spi.HQLQueryPlan.<init> (HQLQueryPlan.java:115)

at org.hibernate.engine.query.spi.HQLQueryPlan.<init> (HQLQueryPlan. java:76)

at org.hibernate.engine.query.spi.QueryPlanCache.getHQLQueryPlan (QueryPlanCache. java:150)

at org.hibernate.internal.AbstractSessionImpl.getHQLQueryPlan (AbstractSessionImpl. java:302)

at org.hibernate.internal.AbstractSessionImpl.createQuery (AbstractSessionImpl. java:240)

at org.hibernate.internal.SessionImpl.createQuery (SessionImpl. java:1894)

at eu.etaxonomy.cdm.persistence.dao.hibernate.taxon.TaxonDaoHibernateImpl.prepareQuery (TaxonDaoHibernateIm
pl.java:398)

at eu.etaxonomy.cdm.persistence.dao.hibernate.taxon.TaxonDaoHibernateImpl.prepareTaxaByName (TaxonDaoHibern
ateImpl. java:601)
at eu.etaxonomy.cdm.persistence.dao.hibernate.taxon.TaxonDaoHibernateImpl.countTaxaByName (TaxonDaoHibernat
eImpl.java:658)

#8 - 01/10/2017 09:42 AM - Katja Luther
- Status changed from In Progress to Resolved

- Assignee changed from Katja Luther to Andreas Kohlbecker

#9 - 01/19/2017 03:28 PM - Andreas Kohlbecker
- Status changed from Resolved to In Progress
- Assignee changed from Andreas Kohlbecker to Katja Luther

- Target version changed from Release 4.5 to Release 4.6

This works now in general but searching only for common names causes an exception:

http://api.cybertaxonomy.org/salvador/portal/taxon/find.json?doTaxaByCommonNames=1&pageNumber=0&pageSize=25&guery=amate&tree=b010c
84d-6049-45{4-9f13-c065101eaa26

(By the way, this is exactly the example request given in the issue description)
please implement a test for this case

#10 - 01/20/2017 11:14 AM - Andreas Kohlbecker

- Description updated

Another broken search request:

http://api.cybertaxonomy.org/flora_cuba/portal/taxon/find.json?doTaxaByCommonNames=1&doSynonyms=1&doTaxa=1&pageNumber=0&pageSize=
25&query=Dioscorea&tree=5de394de-9¢c76-4b97-b04d-71be31c7f44b

| am adding both of them to the description also.

#11 - 01/20/2017 01:01 PM - Katja Luther

- Status changed from In Progress to Resolved

Applied in changeset cdmlib|c4f7a2 7788e2 fc87eb41322

#12 - 01/20/2017 01:02 PM - Katja Luther

- Status changed from Resolved to In Progress

bugs are fixed and tests are added

#13 - 01/23/2017 10:41 AM - Andreas Kohlbecker

There are at least two other problems. | extended the according service tests. You will find in the cdmlib|cc95089 some FIXME sections which are

commented which contain the failing test cases.

#14 - 01/23/2017 12:06 PM - Katja Luther

- Status changed from In Progress to Resolved

Applied in changeset cdmlib|177a283a6184b5ca5ab3344042317{1f96db3b31.

#15 - 01/23/2017 12:30 PM - Andreas Kohlbecker

- Description updated

#16 - 01/23/2017 02:40 PM - Katja Luther

- Target version changed from Release 4.6 to Release 4.5

#17 - 07/31/2017 08:44 PM - Andreas Miiller

- Assignee changed from Katja Luther to Andreas Kohlbecker
Andreas K, could you please review if this is fully fixed now?

#18 - 07/31/2017 08:45 PM - Andreas Miiller

if not, please open new ticket with remaining issues

#19 - 06/11/2018 12:35 PM - Andreas Kohlbecker
- Assignee changed from Andreas Kohlbecker to Katja Luther

- % Done changed from 50 to 100

duplicates are no longer returned, so this issue can in principle be closed, however, as last step cleaning up commented lines in the committed code
would be great!
@Katja, please close this issue once the code cleaning is done.

#20 - 11/12/2021 03:10 PM - Andreas Miiller

Katja, can you have a look? Closing this ticket is needed to cleanup open Salvador issues and to finally close the according milestone.

#21 - 11/15/2021 09:41 AM - Katja Luther

- Status changed from Resolved to Closed

Code cleaning done.
